SystemOrganization addCategory: #'AL-Postgres'!

Notification subclass: #ALPgConnectionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Postgres'!

ALRelay subclass: #ALPgPoolRelay
	instanceVariableNames: 'args idle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Postgres'!

!ALPgPoolRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:41'!
destination: aRelay connectionArgs: aPGConnectionArgs
	^ self basicNew initializeWithDestination: aRelay connectionArgs: aPGConnectionArgs
		! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:14'!
committing: aBoolean do: aBlock 
	| connection sql |
	connection := nil.
	sql := aBoolean ifTrue: ['COMMIT'] ifFalse: ['ROLLBACK'].
	^ [aBlock
		on: ALPgConnectionRequest
		do: 	[:notification | 
			connection ifNil: [connection := self reserveConnection].
			connection executeAndCheckResult: 'BEGIN'.
			notification resume: connection]] 
				ensure:
					[connection ifNotNil: 
						[connection executeAndCheckResult: sql.
						self releaseConnection: connection]]
			! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:15'!
handleRequest: aRequest
	^ self committing: true do: [destination handleRequest: aRequest]! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:42'!
initializeWithDestination: aRelay connectionArgs: aPGConnectionArgs
	self initializeWithDestination: aRelay.
	args := aPGConnectionArgs.
	idle := IdentitySet new.
	! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:10'!
releaseConnection: aPGConnection
	idle add: aPGConnection! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:09'!
reserveConnection
	^ idle isEmpty
		ifFalse: [idle remove: idle anyOne]
		ifTrue: 
			[PGConnection new
				connectionArgs: args;
				startup;
				yourself]
	! !

!ALPgPoolRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2014 11:16'!
write: aMessage into: aWriteStream
	^ self committing: false do: [destination write: aMessage into: aWriteStream]! !

!Object methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 12:19'!
sqlPrintOn: aWriteStream
	aWriteStream
		put: $';
		print: self;
		put: $'! !

!Time methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 13:03'!
sqlPrintOn: aWriteStream
	aWriteStream put: $'.
	self sqlPrintTimePartOn: aWriteStream.
	aWriteStream put: $'! !

!Time methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 13:03'!
sqlPrintTimePartOn: aWriteStream
	{(self hour).
	(self minute).
	(self second)}
		do: [ :num | 
			num < 10
				ifTrue: [ aWriteStream put: $0 ].
			num streamingPrintOn: aWriteStream ]
		separatedBy: [ aWriteStream put: $: ].
	nanos = 0
		ifFalse: [ 
			| b n |
			b := NanosInSecond // 10.
			n := nanos.
			aWriteStream put: $..
			[ 
			n // b streamingPrintOn: aWriteStream.
			(n := n \\ b) = 0 ] whileFalse: [ b := b // 10 ] ]! !

!Date methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 13:02'!
sqlPrintDatePartOn: aWriteStream
	aWriteStream write: self yyyymmdd! !

!Date methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 13:02'!
sqlPrintOn: aWriteStream
	aWriteStream put: $'.
	self sqlPrintDatePartOn: aWriteStream.
	aWriteStream put: $'! !

!UndefinedObject methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 12:56'!
sqlPrintOn: aWriteStream
	aWriteStream write: 'NULL'! !

!DateAndTime methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 13:06'!
sqlPrintOn: aWriteStream
	aWriteStream put: $'.
	self asDate sqlPrintDatePartOn: aWriteStream.
	aWriteStream put: Character space.
	self asTime sqlPrintTimePartOn: aWriteStream.
	aWriteStream put: $'.
	! !

!Number methodsFor: '*al-postgres' stamp: 'cwp 2/24/2014 15:43'!
sqlPrintOn: aWriteStream
	self streamingPrintOn: aWriteStream! !

!XTWriteStream methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 12:18'!
sqlPrint: anObject
	anObject sqlPrintOn: self! !

!String methodsFor: '*al-postgres' stamp: 'cwp 2/20/2014 12:32'!
sqlPrintOn: aWriteStream
	aWriteStream put: $'.
	self do: 
		[:character |
		($' = character) ifTrue: [aWriteStream put: character].
		aWriteStream put: character].
	aWriteStream put: $'! !

!Array methodsFor: '*al-postgres' stamp: 'cwp 2/25/2014 14:52'!
sqlPrintOn: aWriteStream
	aWriteStream write: 'ARRAY['.
	self	
		do: [:ea | ea sqlPrintOn: aWriteStream]
		separatedBy: [aWriteStream put: $,].
	aWriteStream put: $]! !
